--- apt-listchanges.py.orig	2007-05-11 23:45:42.000000000 +0200
+++ apt-listchanges.py	2007-10-08 12:58:00.000000000 +0200
@@ -81,7 +81,14 @@
         status.makeindex('Package')
 
     if config.save_seen:
-        seen = anydbm.open(config.save_seen, 'c')
+        # Open DB. Test if we can read it, and recreate on failure
+        try:
+            seen = anydbm.open(config.save_seen, 'c')
+            seen.has_key('foo%0')
+        except anydbm.error:
+            sys.stderr.write(_("Recreating database %s, because it failed to load.\n") % config.save_seen)
+            os.remove(config.save_seen)
+            seen = anydbm.open(config.save_seen, 'c')
         # Will replace seen after changes have actually been seen
         seen_new = {}
 
